#ifndef FDIMG_H_INCLUDED
#define FDIMG_H_INCLUDED

#include <stdio.h>

#include "tdef.h"

#define	MAX_CYLINDER		82

#define FD_DOUBLESIDE		0x01	// 
#define	FD_DOUBLETRACK		0x02	// {gbN
#define	FD_DOUBLEDENSITY	0x04	// {x
#define	FD_HIGHDENSITY		0x08	// x

#define	FD1D				(FD_DOUBLEDENSITY)
#define	FD2D				(FD_DOUBLESIDE|FD_DOUBLEDENSITY)
#define	FD1DD				(FD_DOUBLETRACK|FD_DOUBLEDENSITY)
#define	FD2DD				(FD_DOUBLESIDE|FD_DOUBLETRACK|FD_DOUBLEDENSITY)
#define	FD2HD				(FD_DOUBLESIDE|FD_DOUBLETRACK|FD_HIGHDENSITY)
#define	FDUNKNOWN			0xff

#define	TRACKCAP(t)			((t)&FD_HIGHDENSITY ? 10416 : (t)&FD_DOUBLEDENSITY ? 6250 : 3125)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// ZN^NX
class cFDSEC {
private:
	BYTE c;							// ID  C (V_No Жʂ̏ꍇ=gbNNo)
	BYTE h;							// ID  H (wb_AhX Жʂ̏ꍇ=0)
	BYTE r;							// ID  R (gbÑZN^No)
	BYTE n;							// ID  N (ZN^TCY 0:128 1:256 2:512 3:1024)
	BYTE deleted;					// DELETED MARK 0x00:m[} 0x10:DELETED
	BYTE status;					// Xe[^X
	
	WORD dsize;						// ̃ZN^̃f[^TCY
	BYTE *data;						// f[^ւ̃|C^
	
	cFDSEC *next;					// ̃ZN^ւ̃|C^
	
public:
	cFDSEC( BYTE, BYTE, BYTE, BYTE, BYTE=0, BYTE=0 );	// RXgN^
	~cFDSEC();						// fXgN^
	
	BYTE C();						// C擾
	BYTE H();						// H擾
	BYTE R();						// R擾
	BYTE N();						// N擾
	BYTE Deleted();					// DELETED MARK擾
	void SetDeleted( BYTE );		// DELETED MARKݒ
	BYTE Status();					// Xe[^X擾
	void SetStatus( BYTE );			// Xe[^Xݒ
	WORD DataSize();				// f[^TCY擾
	BYTE *Buffer();					// f[^ւ̃|C^擾
	
	BOOL GetData( BYTE *, WORD );	// f[^擾
	BOOL SetData( BYTE *, WORD );	// f[^ݒ
	
	BOOL Resize( BYTE );			// f[^TCYύX
	
	cFDSEC *Next();					// ̃ZN^ւ̃|C^擾
	void SetNext( cFDSEC * );		// ̃ZN^ւ̃|C^ݒ
};

// gbNNX
class cFDTRK {
private:
	cFDSEC *sectors;				// ZN^IuWFNgւ̃|C^
	BYTE density;					// L^x     0x00:{x   0x40:Px
	BYTE gap3;						// GAP3f[^
	
public:
	cFDTRK();						// RXgN^
	~cFDTRK();						// fXgN^
	
	BYTE Count();					// ZN^擾
	cFDSEC *Sector( BYTE );			// ZN^擾
	cFDSEC *AddSector( BYTE, BYTE, BYTE, BYTE, BYTE=0xff, BYTE=0, BYTE=0 );	// ZN^ǉ
	
	BYTE Gap3();					// GAP3擾
	void SetGap3( BYTE );			// GAP3ݒ
	BYTE Density();					// L^x擾
	void SetDensity( BYTE );		// L^xݒ
	
	BOOL Format( BYTE, BYTE, BYTE, BYTE );	// tH[}bg
	void Unformat();				// AtH[}bg
	
};

// tbs[fBXNC[WNX
class cFDimg {
protected:
	cFDTRK track[MAX_CYLINDER*2];	// gbNe[u
	char title[256];				// fBXN̖O
	BYTE type;						// fBXN̎(1D,2D,1DD,2DD,2HD)
	BOOL protect;					// CgveNg
	
	virtual BOOL ReadFileTrack( FILE *, BYTE, cFDTRK * ) = 0;	// gbNf[^Ǎ
	virtual BOOL WriteFileTrack( FILE *, BYTE, cFDTRK * ) = 0;	// gbNf[^
	
	BOOL IsSingleSide();			// ЖʃfBXN?
	
public:
	cFDimg();						// RXgN^
	~cFDimg();						// fXgN^
	
	cFDTRK *Track( BYTE, BYTE );	// gbN擾
	char *Title();					// fBXN̖O擾
	void SetTitle( const char * );	// fBXN̖Oݒ
	BYTE Type();					// fBXN̎ގ擾
	void SetType( BYTE );			// fBXN̎ސݒ
	BOOL Protect();					// CgveNg擾
	void SetProtect( BOOL );		// CgveNgݒ
	
	void Unformat();				// AtH[}bg
	
	virtual BOOL ReadFromFile( const char * ) = 0;	// C[Wt@CǍ
	virtual BOOL WriteToFile( const char * ) = 0;	// C[Wt@Cɏ
};


// D88fBXNC[WNX
class D88DISK : public cFDimg {
private:
	BOOL ReadFileTrack( FILE *, BYTE, cFDTRK * );	// gbNf[^Ǎ
	BOOL WriteFileTrack( FILE *, BYTE, cFDTRK * );	// gbNf[^
	
public:
	D88DISK();						// RXgN^
	~D88DISK();						// fXgN^
	
	BOOL ReadFromFile( const char * );	// C[Wt@CǍ
	BOOL WriteToFile( const char * );	// C[Wt@Cɏ
};


#endif
